Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkImageBlend Class Reference

`#include <vtkImageBlend.h>`

Inheritance diagram for vtkImageBlend:

[legend]
Collaboration diagram for vtkImageBlend:

[legend]
List of all members.

## Detailed Description

blend images together using alpha or opacity

Date:
  2002/12/11 14:26:22

Revision:
  1.20

vtkImageBlend takes L, LA, RGB, or RGBA images as input and blends them according to the alpha values and/or the opacity setting for each input.

The spacing, origin, extent, and number of components of the output are the same as those for the first input. If the input has an alpha component, then this component is copied unchanged into the output. In addition, if the first input has either one component or two components i.e. if it is either L (greyscale) or LA (greyscale + alpha) then all other inputs must also be L or LA.

Different blending modes are available:

Normal (default) : This is the standard blending mode used by OpenGL and other graphics packages. The output always has the same number of components and the same extent as the first input. The alpha value of the first input is not used in the blending computation, instead it is copied directly to the output.

     output <- input[0]
     foreach input i {
       foreach pixel px {
         r <- input[i](px)(alpha) * opacity[i]
         f <- (255 - r)
         output(px) <- output(px) * f + input(px) * r
       }
     }

Compound : Images are compounded together and each component is scaled by the sum of the alpha/opacity values. Use the CompoundThreshold method to set specify a threshold in compound mode. Pixels with opacity*alpha less or equal than this threshold are ignored. The alpha value of the first input, if present, is NOT copied to the alpha value of the output. The output always has the same number of components and the same extent as the first input.

     output <- 0
     foreach pixel px {
       sum <- 0
       foreach input i {
         r <- input[i](px)(alpha) * opacity(i)
         sum <- sum + r
         if r > threshold {
           output(px) <- output(px) + input(px) * r
         }
       }
       output(px) <- output(px) / sum
     }

Created by:
  - Gobbi, David

CVS contributions (if > 5%):
  - Gobbi, David (58%)
  - Barre, Sebastien (33%)

CVS logs (CVSweb):
  - .`cxx` (`/Imaging/vtkImageBlend.cxx)`
  - .`h` (`/Imaging/vtkImageBlend.h)`

Tests:
  vtkImageBlend (Tests)

Definition at line 102 of file vtkImageBlend.h.

## Public Types
typedef vtkImageMultipleInputFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | SetOpacity (int idx, double opacity)
double | GetOpacity (int idx)
virtual void | SetStencil (vtkImageStencilData *)
virtual vtkImageStencilData * | GetStencil ()
virtual void | SetBlendMode (int)
virtual int | GetBlendMode ()
void | SetBlendModeToNormal ()
void | SetBlendModeToCompound ()
const char * | GetBlendModeAsString (void)
virtual void | SetCompoundThreshold (float)
virtual float | GetCompoundThreshold ()
## Static Public Methods
vtkImageBlend * | New ()
int | IsTypeOf (const char *type)
vtkImageBlend * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkImageBlend ()
| ~vtkImageBlend ()
void | ComputeInputUpdateExtent (int inExt[6], int outExt[6], int whichInput)
void | ExecuteInformation ()
void | ExecuteInformation (vtkImageData **, vtkImageData *)
void | ThreadedExecute (vtkImageData **inDatas, vtkImageData *outData, int extent[6], int id)
void | ExecuteData (vtkDataObject *output)
## Protected Attributes
vtkImageStencilData * | Stencil
double * | Opacity
int | OpacityArrayLength
int | BlendMode
float | CompoundThreshold
int | DataWasPassed

## Member Typedef Documentation

typedef vtkImageMultipleInputFilter vtkImageBlend::Superclass

| Reimplemented from vtkImageMultipleInputFilter. Definition at line 106 of file vtkImageBlend.h.

## Constructor & Destructor Documentation

vtkImageBlend::vtkImageBlend | ( |  | ) | `[protected]`

vtkImageBlend::~vtkImageBlend | ( |  | ) | `[protected]`

## Member Function Documentation

vtkImageBlend* vtkImageBlend::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkImageBlend::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkImageMultipleInputFilter.

int vtkImageBlend::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkImageMultipleInputFilter.

virtual int vtkImageBlend::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkImageMultipleInputFilter.

vtkImageBlend* vtkImageBlend::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkImageMultipleInputFilter.

void vtkImageBlend::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkImageMultipleInputFilter.

void vtkImageBlend::SetOpacity | ( | int | idx,
|  | double | opacity
| ) |

| Set the opacity of an input image: the alpha values of the image are multiplied by the opacity. The opacity of image idx=0 is ignored.

double vtkImageBlend::GetOpacity | ( | int | idx | ) |

| Set the opacity of an input image: the alpha values of the image are multiplied by the opacity. The opacity of image idx=0 is ignored.

virtual void vtkImageBlend::SetStencil | ( | vtkImageStencilData * |  | ) | `[virtual]`

| Set a stencil to apply when blending the data.

virtual vtkImageStencilData* vtkImageBlend::GetStencil | ( |  | ) | `[virtual]`

| Set a stencil to apply when blending the data.

virtual void vtkImageBlend::SetBlendMode | ( | int |  | ) | `[virtual]`

| Set the blend mode

virtual int vtkImageBlend::GetBlendMode | ( |  | ) | `[virtual]`

| Set the blend mode

void vtkImageBlend::SetBlendModeToNormal | ( |  | ) | `[inline]`

| Set the blend mode Definition at line 128 of file vtkImageBlend.h. References VTK_IMAGE_BLEND_MODE_NORMAL.

void vtkImageBlend::SetBlendModeToCompound | ( |  | ) | `[inline]`

| Set the blend mode Definition at line 130 of file vtkImageBlend.h. References VTK_IMAGE_BLEND_MODE_COMPOUND.

const char * vtkImageBlend::GetBlendModeAsString | ( | void |  | ) | `[inline]`

| Get the blending mode as a descriptive string Definition at line 173 of file vtkImageBlend.h. References BlendMode, VTK_IMAGE_BLEND_MODE_COMPOUND, and VTK_IMAGE_BLEND_MODE_NORMAL.

virtual void vtkImageBlend::SetCompoundThreshold | ( | float |  | ) | `[virtual]`

| Specify a threshold in compound mode. Pixels with opacity*alpha less or equal the threshold are ignored.

virtual float vtkImageBlend::GetCompoundThreshold | ( |  | ) | `[virtual]`

| Specify a threshold in compound mode. Pixels with opacity*alpha less or equal the threshold are ignored.

void vtkImageBlend::ComputeInputUpdateExtent | ( | int | inExt[6],
|  | int | outExt[6],
|  | int | whichInput
| ) | `[protected, virtual]`

| Reimplemented from vtkImageMultipleInputFilter.

void vtkImageBlend::ExecuteInformation | ( |  | ) | `[inline, protected, virtual]`

| Reimplemented from vtkImageMultipleInputFilter. Definition at line 149 of file vtkImageBlend.h. References vtkImageMultipleInputFilter::ExecuteInformation().

void vtkImageBlend::ExecuteInformation | ( | vtkImageData ** | ,
|  | vtkImageData * |
| ) | `[protected, virtual]`

| Reimplemented from vtkImageMultipleInputFilter.

void vtkImageBlend::ThreadedExecute | ( | vtkImageData ** | inDatas,
|  | vtkImageData * | outData,
|  | int | extent[6],
|  | int | id
| ) | `[protected, virtual]`

| The execute method created by the subclass. This is kept public instead of protected since it is called from a non-member thread function. Reimplemented from vtkImageMultipleInputFilter.

void vtkImageBlend::ExecuteData | ( | vtkDataObject * | output | ) | `[protected]`

| Reimplemented from vtkImageMultipleInputFilter.

## Member Data Documentation

vtkImageStencilData* vtkImageBlend::Stencil`[protected]`

| Definition at line 161 of file vtkImageBlend.h.

double* vtkImageBlend::Opacity`[protected]`

| Definition at line 162 of file vtkImageBlend.h.

int vtkImageBlend::OpacityArrayLength`[protected]`

| Definition at line 163 of file vtkImageBlend.h.

int vtkImageBlend::BlendMode`[protected]`

| Definition at line 164 of file vtkImageBlend.h. Referenced by GetBlendModeAsString().

float vtkImageBlend::CompoundThreshold`[protected]`

| Definition at line 165 of file vtkImageBlend.h.

int vtkImageBlend::DataWasPassed`[protected]`

| Definition at line 166 of file vtkImageBlend.h.

The documentation for this class was generated from the following file:

- Imaging/vtkImageBlend.h